var curpage = 0, wakelock;
window.addEventListener('keydown',keyhandle);

function keyhandle(k) {
	if(curpage !== 0) {
		switch(curpage) {
			case 1:menuK(k);break;
			case 2:settingsK(k);break;
			case 3:colorchangeK(k);break;
			case 4:aboutK(k);break;
			case 5:tutorialK(k);break;
		}
		return;
	}
	switch(k.key) {
		case 'SoftRight': menuK(); break;
		case 'SoftLeft': loadsettings(); break;
		case 'Enter': 
		if(audio.src.src) {
			if(audio.src.paused) {
				audio.src.play();
			} else {
				audio.src.pause();
			} 
		} else {
			alertMessage('Please load some audio first!');
		}
		break;
		case '0': shosd(); break;

		case 'ArrowLeft': cyclevis(-1); break;
		case 'ArrowRight': cyclevis(1); break;

		case 'ArrowUp':
		case 'ArrowDown':
			navigator.volumeManager.requestShow();
			break;
		
		//case 'ArrowUp': navigator.volumeManager.requestUp(); break;
		//case 'ArrowDown': navigator.volumeManager.requestDown(); break;

		case 'Backspace':
			if(document.fullscreenElement) {
				k.preventDefault();
				fullscreen();
			}
			break;

	}

	updatenavbar();
}

window.addEventListener('load',function(){
	globalrender();
	settingsMemory('load');
	loadlastvis();
	canvasrecalc();

	audio.src.addEventListener('pause',function(){
		updatenavbar();
		wakelock.unlock();
/* 			for(; 0 < wakelock.length;) {
			wakelock[0].unlock();
			wakelock.splice(0,1);
		}
*/	
	});
	
	audio.src.addEventListener('play',function(){
		updatenavbar();
		wakelock = navigator.requestWakeLock('screen');
	});

	audio.src.addEventListener('ended',function(){
		fullscreen(false);
	})

	/* document.addEventListener('fullscreenchange',function(){
		if(document.fullscreenElement || document.mozFullScreenEnabled) {
			document.getElementById('menu-in').children[1].textContent = 'Exit Fullscreen'; //2nd item is the fullscreen opt
		} else {
			document.getElementById('menu-in').children[1].textContent = 'Fullscreen'; 
		}
	}); */

	/* if(navigator.largeTextEnabled) {
		document.body.classList.add('largetext');
	} */

	navigator.mozAudioChannelManager.addEventListener('headphoneschange',function(){
	    if(!navigator.mozAudioChannelManager.headphones) {
	        audio.src.pause();
	    }
	}); //headhpone handeler if unplug
});


var osdshow = false;
function shosd() {
	if(osdshow) {
		document.getElementById('osd').style.display = 'none';
	} else {
		document.getElementById('osd').style.display = null;
	}

	osdshow = !osdshow;
}
//var files = document.getElementById('filelist');
//files.addEventListener('change',changemus);
function loadFile() {
	var lfa = new MozActivity({
		name: 'pick',
		data: {type: ['audio/*']}
	});

	lfa.onsuccess = changemus;
	lfa.onerror = function(e){console.error(e);}

	fullscreen(false);
}

function changemus(blob) {
	blob = blob.target.result;
	
	if('blob' in blob) {
		blob = blob.blob;
	} else {
		console.error('MozActivity resulted in success, however there is no blob available.');
		return;
	}

	//vmc.self.unload();
	vmc.self.load(audio.src,vmc.loaded);

	keeprendering = true;

	if(!audio.src.paused) {audio.src.pause();}
	updatenavbar();
	if(audio.src.src) {URL.revokeObjectURL(audio.src.src);}

	audio.src.src = URL.createObjectURL(blob);


	if(!localStorage.getItem('firstrun')) {
		tutorialK();
		localStorage.setItem('firstrun','1')
	} else {
		document.getElementById('loadmessage').style.display = 'none';
	}
}

screen.addEventListener('mozorientationchange',canvasrecalc);

function canvasrecalc() {
	canvas.width = screen.availWidth;
	canvas.height = screen.availHeight;

	//console.log('canvasrecalc');
}

var menuKsel = 0;
function menuK(k) {
	if(curpage === 1) {
		var pgch = true, //page change
		menuitems = [];
		var miht = document.getElementsByClassName('menu-item');
		for(var i = 0; i < miht.length; i++) {menuitems.push(miht[i]);}
		miht = undefined;
		if('theAdvert' in window) {if(theAdvert && theAdvertReady) {menuitems.push(document.getElementById('advert-container'))}}
		switch(k.key) {
			case 'ArrowUp': done=false; menuKsel=navigatelist(menuKsel,menuitems,-1); updatenavbar(); break;
			case 'ArrowDown': done=false; menuKsel=navigatelist(menuKsel,menuitems,1); updatenavbar(); break;
			case 'Enter': 
				switch(menuKsel) {
					case 0: loadFile(); break; //load a song
					case 1: fullscreen(); break; //i wonder what this does?
					case 2: rotate(); break; //rotate the screen
					case 3: settingsMemory('save'); break; //save settings
					case 4: aboutK(); pgch=false; break; //about screen
					case 5: clickadvert(); break; //click the ad.
				};
				//dont break, continue to the close action.
			case 'Backspace':
			case 'SoftRight':
				k.preventDefault();
				document.getElementById('menu').style.display = 'none';
				if(pgch) {
					curpage = 0;
					//document.body.classList.remove('darker');
				}
				updatenavbar();	
				break;
		
			
		}

	} else {
		curpage = 1;
		menuKsel = 0;
		document.getElementById('menu').style.display = null;
		document.getElementById('menu-in').children[0].focus(); //menu-in children excludes the advert, no need to check whether the ad has loaded or not.
	}
}

function aboutK(k) {
	if(curpage !== 4) {
		curpage = 4;
		//console.log(curpage = 4);
		//document.body.classList.add('darker'); //already should be active when menu is opened
		document.getElementById('about').style.display = null;
		document.getElementById('about').scrollTo(0,0);
		document.getElementById('about').focus();
	} else {
		switch(k.key) {
			case 'Backspace':
			case 'SoftLeft':
				k.preventDefault();
				curpage = 0;
				document.getElementById('about').style.display = 'none';
				//document.body.classList.remove('darker');
				updatenavbar();
				break;
			}
	}
}